package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Suppliers;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.boss.ApothBoss;
import dev.shadowsoffire.apotheosis.adventure.boss.BossRegistry;
import dev.shadowsoffire.apotheosis.adventure.compat.GatewaysCompat;
import dev.shadowsoffire.gateways.gate.WaveEntity;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import java.util.Objects;
import java.util.Optional;
import java.util.function.Function;
import java.util.function.Supplier;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.ServerLevelAccessor;

public class BossWaveEntity implements WaveEntity {
  public static Codec<BossWaveEntity> CODEC;
  
  private final Optional<ResourceLocation> bossId;
  
  private final Supplier<ApothBoss> boss;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)PlaceboCodecs.nullableField(ResourceLocation.f_135803_, "boss").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.compat.GatewaysCompat.BossWaveEntity::new));
  }
  
  public BossWaveEntity(Optional<ResourceLocation> bossId) {
    this.bossId = bossId;
    this.boss = (Supplier<ApothBoss>)Suppliers.memoize(() -> {
          Objects.requireNonNull(BossRegistry.INSTANCE);
          return bossId.map(BossRegistry.INSTANCE::getValue).orElse(null);
        });
  }
  
  public LivingEntity createEntity(Level level) {
    ApothBoss realBoss = this.bossId.isEmpty() ? (ApothBoss)BossRegistry.INSTANCE.getRandomItem(level.f_46441_) : this.boss.get();
    if (realBoss == null)
      return null; 
    return (LivingEntity)realBoss.createBoss((ServerLevelAccessor)level, BlockPos.f_121853_, level.f_46441_, 0.0F);
  }
  
  public MutableComponent getDescription() {
    return Component.m_237110_("misc.apotheosis.boss", new Object[] { Component.m_237115_(this.bossId.isEmpty() ? "misc.apotheosis.random" : ((ApothBoss)this.boss.get()).getEntity().m_20675_()) });
  }
  
  public boolean shouldFinalizeSpawn() {
    return false;
  }
  
  public Codec<? extends WaveEntity> getCodec() {
    return (Codec)CODEC;
  }
  
  public int getCount() {
    return 1;
  }
}
